// This code from "Recursion Primer using C++", Part 1 by Zeeshan Amjad //
// It runs on my Non Modern Compiler (2010) HP laptop
//Multi Dimensional Class using Template Recursion. (Compile time and Runtime)
//Meta Programming, Compile time with Runtime example.
#include <iostream>
#include <vector>
#include <iterator>
template <typename T, int Dim>
class Array
{
private:
   // recursively create object
   Array<T, Dim - 1> vecRow;
 
public:
   Array(int iSize = 0)
   {
      vecRow.Resize(iSize);
   }
 
   void Resize(size_t iSize)
   {
      vecRow.Resize(iSize);
   }
 
   size_t Size()
   {
      return vecRow.Size();
   }
 
   Array<T, Dim - 1>& operator [] (size_t x)
   {
      if (x >= 0 && x < vecRow.Size())
      {
         return vecRow;
      }
 
      throw std::out_of_range("Index is out of range");
   }
 
};
// specialized class to stop recursion
template <typename T>
class Array<T, 1>
{
private:
    std::vector<T> vecRow;

public:
    Array(int iSize = 10)
    {
        Resize(iSize);
    }

    void Resize(size_t iSize)
    {
        vecRow.resize(iSize);
    }

    size_t Size()
    {
        return vecRow.size();
    }

    T& operator [] (size_t x)
    {
        if (x >= 0 && x < vecRow.size())
        {
            return vecRow.at(x);
        }

        throw std::out_of_range("Index is out of range");
    }
};
int main() {
 //   std::cout <<  << std::endl;
    Array <int,3>obj(10);
    obj[0][0][0] = 100;
    obj[0][1][0] = 200;
    obj[1][2][0] = 300;
    obj[0][3][0] = 400;

    std::cout << obj[0][0][0] << std::endl;
    std::cout << obj[0][3][0] << std::endl;
    std::cout << obj[1][3][0] << std::endl;
    std::cout << obj[0][3][1] << std::endl;
    std::cout << obj[1][3][1] << std::endl;
    obj[0][3][1] = 450;
    std::cout << obj[0][3][1] << std::endl;
}